package com.muzhi.tianhe.service.impl;

import com.auth0.jwt.JWT;
import com.auth0.jwt.algorithms.Algorithm;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.request.OapiGettokenRequest;
import com.dingtalk.api.response.OapiGettokenResponse;
import com.muzhi.tianhe.service.AccessTokenService;
import com.taobao.api.ApiException;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.Date;


/**
 * @Author ZhangKan
 * @Data 15:39
 */

@Service
public class AccessTokenServiceImpl implements AccessTokenService {
    //AccessTokenService

    //易控
    //AgentId:
    //APPKEY
    private static String APPKEY = "";
    //APPSECRET
    private static String APPSECRET = "";

    public static String accessToken = null;


    //获取access_token的方法（易控）
    @Override
    public String getAccessToken() {
        DefaultDingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/gettoken");
        OapiGettokenRequest request = new OapiGettokenRequest();
        request.setAppkey(APPKEY);
        request.setAppsecret(APPSECRET);
        request.setHttpMethod("GET");
        try {
            OapiGettokenResponse response = client.execute(request);
            accessToken = response.getAccessToken();
            System.out.println("易控AccessToken：" + accessToken);
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return accessToken;
    }


    public static final Long   EXPIRES_IN = 1 * 3600 * 1000L;
    public static final String TOKEN_APPID = "_appId";

    public static String appId = "65f92ac8046a09f810107919";
    public static String appSecret = "fy9OcKys3ZMdPnj0jvATrni5LvEn8ksk";
    //获取access_token的方法（TB应用）
    @Override
    public String getAppToken() {
        if (StringUtils.isEmpty(appId) || StringUtils.isEmpty(appSecret)) {
            return null;
        }

        Algorithm algorithm = Algorithm.HMAC256(appSecret);
        long timestamp = System.currentTimeMillis();
        Date issuedAt = new Date(timestamp);
        Date expiresAt = new Date(timestamp + EXPIRES_IN);

//        return JWT.create()
//                .withClaim(TOKEN_APPID, appId)
//                .withIssuedAt(issuedAt)
//                .withExpiresAt(expiresAt)
//                .sign(algorithm);

        String sign = JWT.create()
                .withClaim(TOKEN_APPID, appId)
                .withIssuedAt(issuedAt)
                .withExpiresAt(expiresAt)
                .sign(algorithm);
//        System.out.println("TB应用的AccessToken：" + sign);

        return sign;

    }

}
