package com.muzhi.tianhe.service.impl;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.muzhi.tianhe.service.AccessTokenService;
import com.muzhi.tianhe.util.PublicUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

@Service
@Slf4j
public class TbApiService {

    @Autowired
    private AccessTokenService accessTokenService;
    //私有化
    public static String PRIVATE_API_URL = "https://tb.trinasolar.com/gateway";
//    public static String PRIVATE_API_URL = "https://tb.trinasolar.com/gateway";

    public static String DING_CORP_ID = "dinga41ec6a58a4911d0f2c783f7214b6d69";
    public static String tbOrganizationId = "65b1dca21ab0fa13be993595";
    public static String tbOperatorId = "65b1dc8355d0f38026a1c3db"; // guhuchen

    public JSONArray getProjectList(){
        JSONObject result=new JSONObject();
        JSONArray array=new JSONArray();
        do {
            result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/query?pageSize=1000&pageToken="+result.getString("nextPageToken")));
            array.addAll(result.getJSONArray("result"));
        }while (!PublicUtil.isNull(result.getString("nextPageToken")));
        return array;
    }

    public JSONArray getProjectInfo(String projectId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/query?projectIds=" + projectId + "&pageSize=1000"));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksType(String xmid){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/" + xmid + "/scenariofieldconfig/search"));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksByType(String xmid,String rwlxid){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/" + xmid + "/task/query?q=sfcId = " + rwlxid + "&pageSize=1000"));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksInfo(String taskId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/task/query?taskId="+taskId));
        return result.getJSONArray("result");
    }

    public JSONArray getTasksByParent(String parentTaskId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/task/query?parentTaskId="+parentTaskId));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectTfid(String projectId,String q){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/"+projectId+"/taskflow/search?q="+q));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectStateId(String projectId,String q,String tfIds,String tfsIds){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/"+projectId+"/taskflowstatus/search?q="+q+"&tfIds="+tfIds+"&tfsIds="+tfsIds));
        return result.getJSONArray("result");
    }

    public Object updateTaskStatus(String taskId,String taskflowstatusId){
        Map map=new HashMap();
        map.put("taskflowstatusId",taskflowstatusId);
        JSONObject result=header(HttpRequest.put(PRIVATE_API_URL + "/v3/task/{taskId}/taskflowstatus".replace("{taskId}",taskId))
                .header("x-operator-id",tbOperatorId)
                .body(JSONObject.toJSONString(map)));
        return result;
    }

    public JSONArray getProjectCust(String projectId){
        JSONObject result=header(HttpRequest.get(PRIVATE_API_URL + "/v3/project/"+ projectId +"/status/customfield/list"));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectRoleMember(String projectId,String id){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/"+ projectId +"/member").form("projectRoleId",id));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectTag(String projectId){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/{projectId}/project-tag".replace("{projectId}",projectId)));
        return result.getJSONArray("result");
    }

    public JSONArray getProjecGrouptTag(String id){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project-tag/query").form(new JSONObject().fluentPut("ids",id)));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectState(String projectId){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "v3/project/{projectId}/taskflowstatus/search".replace("{projectId}",projectId)));
        return result.getJSONArray("result");
    }

    public JSONArray getProjecTagUser(String projectTagId){
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project-tag/{projectTagId}/project/query".replace("{projectTagId}",projectTagId)));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectRole(String projectId){
        Map param = new HashMap();
        param.put("pageSize", 1000);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/" + projectId + "/role")
                .form(param));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectMemberRole(String projectId,String userIds){
        Map param = new HashMap();
        param.put("userIds", userIds);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/"+projectId+"/member-role")
                .form(param));
        return result.getJSONArray("result");
    }

    public JSONArray getProjectMember(String projectId){
        Map param = new HashMap();
        param.put("pageSize", 1000);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/"+projectId+"/member")
                .form(param));
        return result.getJSONArray("result");
    }

    public JSONArray userSearch(String userId){
        Map param = new HashMap();
        param.put("orgId",tbOrganizationId);
        param.put("query",userId);
        param.put("pageSize", 1000);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/org/member/search")
                .form(param));
        return result.getJSONArray("result");
    }

    public JSONArray idMapQuery(String userId, boolean isTbID){
        Map param = new HashMap();
        param.put("refer","dingTalk-user");
        param.put("refId",DING_CORP_ID);
        param.put(isTbID ? "tbId" : "extraUserId", userId);
        JSONObject result=header(HttpUtil.createGet(PRIVATE_API_URL + "/idmap/query")
                .form(param));
        return result.getJSONArray("result");
    }



    private JSONObject header(HttpRequest request){
        try {
            request.header("Authorization","Bearer " + accessTokenService.getAppToken())
                    .header("X-Tenant-Id", tbOrganizationId)
                    .header("X-Tenant-Type", "organization");
            String resultStr=request.execute().body();
            JSONObject result=JSONObject.parseObject(resultStr);
            if(!result.getString("code").equals("200")){
                log.error("请求失败！返回数据：{}",resultStr);
                return new JSONObject();
            }
            return result;
        }catch (Exception e){
            e.printStackTrace();
            log.error("请求异常！错误信息：{}",e);
            return new JSONObject();
        }
    }

}
