package com.muzhi.tianhe.service.impl;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.muzhi.tianhe.entity.User;
import com.muzhi.tianhe.mapper.TianheMapper;
import com.muzhi.tianhe.service.AccessTokenService;
import com.muzhi.tianhe.service.TbProjectZbService;
import lombok.extern.slf4j.Slf4j;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

@Slf4j
@Service
public class TbProjectZbServiceImpl implements TbProjectZbService {

    @Autowired
    private TianheMapper tianheMapper;
    @Autowired
    private AccessTokenService accessTokenService;
    private static String PRIVATE_API_URL = "https://tb.trinasolar.com/gateway";
    private static String tbOrganizationId = "65b1dca21ab0fa13be993595";
    //缓存用户信息
    private static Map<String,User> USER_MAP=new HashMap<>();
    //缓存项目里程碑
    private static Map<String,String> TB_LICHENGBEI_MAP=new HashMap<>();
    //缓存项目分组成员
    private static Map<String,String> TB_PROJECT_GROUP_MAP=new HashMap<>();

    @Override
    @Async
    public void sync() {
        //先删除清空tianhe表中的所有数据
        tianheMapper.delete(null);
        //再执行插入TB统计数据库表的接口
        getXiangmu();
    }

    private void getXiangmu(){
        HttpRequest request=HttpUtil.createGet(PRIVATE_API_URL + "/v3/project/query?pageSize=1000").header(header());
        JSONArray result2 = null;
        try {
            String bodyStr = request.execute().body();
            JSONObject jsonObject = JSON.parseObject(bodyStr);
            result2 = jsonObject.getJSONArray("result");
        }catch (Exception e){
            e.printStackTrace();
            log.error("同步异常！");
            return;
        }
        for (int ii = 0; ii < result2.size(); ii++) {
            //项目id
            String xmid = result2.getJSONObject(ii).getString("id");
            syncData(xmid);
        }
    }

    private void syncData(String xmid){
//        /**数据库表*/
//        JSONArray xiangmuRenwuLeixing = getXiangmuRenwuLeixing(xmid);
//        for (int j = 0; j < xiangmuRenwuLeixing.size(); j++) {
//            JSONObject jsonObject1 = xiangmuRenwuLeixing.getJSONObject(j);
//            String renwuleixingName = jsonObject1.getString("name");
//            if (renwuleixingName.equals("周报")){
//                // 获取属于【周报】的任务
//                getZhoubao(jsonObject1.getString("id"),xmid);
//            }else if (renwuleixingName.equals("里程碑")){
//                // 获取项目里程碑
//                getLichengbei(jsonObject1.getString("id"),xmid);
//            }
//        }
    }

    private Map header(){
        Map map=new HashMap();
        map.put("Authorization","Bearer " + accessTokenService.getAppToken());
        map.put("X-Tenant-Id", tbOrganizationId);
        map.put("X-Tenant-Type", "organization");
        return map;
    }

}
